<script lang="ts">
import Vue from 'vue';
import { HorizontalScrollBar } from '../common/index.vue';

export default Vue.extend({
  components: {
    HorizontalScrollBar,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      progress: 0,
    };
  },
  mounted() {
    const { cards } = this.$refs;
    cards.$el.addEventListener(
      'scroll',

      function (e) {
        const { clientWidth } = e.target;
        const { scrollLeft } = e.target;
        const { scrollWidth } = e.target;

        const scrollPercent = scrollLeft / (scrollWidth - clientWidth);
        const scrollPercentRounded = Math.round(scrollPercent * 100);
        this.progress = scrollPercentRounded;
      }.bind(this),
    );
  },
});
</script>

<template>
  <SlpContainer>
    <SlpRow class="resources-block__header">
      <SlpTypography tag="h2" variant="heading2-bold">
        {{ data.header_text }}
      </SlpTypography>
      <SlpButton
        variant="tertiary"
        :href="data.header_cta_href"
        :data-ga-name="data.header_cta_ga_name"
        :data-ga-location="data.header_cta_ga_location"
        >{{ data.header_cta_text }}

        <SlpIcon
          class="slp-ml-8"
          name="chevron-lg-right"
          variant="product"
          alt="Chevron Right Icon"
        />
      </SlpButton>
    </SlpRow>

    <SlpRow ref="cards" class="resources-block__cards">
      <SlpColumn
        v-for="(card, index) in data.cards"
        :key="index"
        :cols="data.column_size"
        class="slp-mb-48 card"
      >
        <a
          :href="card.href"
          class="resources-block"
          :data-ga-name="card.data_ga_name"
          :data-ga-location="card.data_ga_location"
        >
          <div class="resources-block__wrapper">
            <div class="resources-block__content-top">
              <div class="resources-block__icon slp-flex">
                <SlpIcon
                  v-if="card.icon"
                  :name="card.icon.name"
                  :variant="card.icon.variant"
                  :alt="card.icon.alt"
                  :hex-color="card.icon.hex_color"
                />
                <SlpTypography
                  tag="p"
                  variant="body2"
                  class="resources-block__type"
                  >{{ card.event_type }}
                </SlpTypography>
              </div>
              <img
                :src="card.image"
                :alt="card.alt"
                class="resources-block__image slp-my-24"
                loading="lazy"
              />
              <SlpTypography tag="h3" variant="body1"
                >{{ card.header }}
              </SlpTypography>
            </div>
            <div class="resources-block__content-bottom">
              <SlpTypography
                variant="button"
                tag="div"
                class="resources-block__link"
                >{{ card.link_text }}
                <SlpIcon
                  class="slp-ml-8"
                  name="chevron-lg-right"
                  variant="product"
                  hex-color="#171321"
                />
              </SlpTypography>
            </div>
          </div>
        </a>
      </SlpColumn>
    </SlpRow>
    <HorizontalScrollBar class="horizontal-scroll" :value="progress" />
  </SlpContainer>
</template>

<style scoped lang="scss">
.horizontal-scroll {
  display: none;
}

.resources-block__header {
  width: 100%;
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  align-items: center;
  padding-bottom: $spacing-32;
  border-bottom: 2px solid $color-surface-400;
  margin-bottom: $spacing-32;
}

.slp-text-button,
.slp-btn-tertiary {
  font-weight: 600;
  color: $color-text-300;
}

.slp-btn svg,
.resources-block__link svg {
  vertical-align: middle;
  margin-left: $spacing-4;
}

.resources-block {
  cursor: pointer;
  display: flex;
  position: relative;
  height: 100%;
  flex-basis: 0;
  flex-grow: 1;

  @media (min-width: $breakpoint-md) {
    margin: $spacing-16 $spacing-16 $spacing-16 0;
  }

  &__wrapper {
    display: flex;
    flex-direction: column;
    transition: all 0.3s ease-in-out;
    justify-content: space-between;
    padding: $spacing-16;
    flex: 1;

    &:hover {
      background: $color-surface-900;
      border-radius: 0 0 100px 0;
    }
  }

  &__link {
    display: flex;
    align-items: center;
    color: $color-text-300;
    padding-left: 0;
  }

  &__type {
    margin-left: $spacing-8;
  }

  &__content-top {
    p,
    h3 {
      color: $color-text-300;
    }
    @media (min-width: $breakpoint-md) and (max-width: $breakpoint-lg) {
      margin-bottom: $spacing-32;
    }
  }

  &__content-bottom {
    @media (min-width: $breakpoint-md) and (max-width: $breakpoint-lg) {
      margin-top: $spacing-32;
    }
  }

  &__image {
    max-width: 100%;
    max-height: 230px;
    height: 100%;

    @media (max-width: $breakpoint-md) {
      max-height: 163px;
    }

    @media (min-width: $breakpoint-md) and (max-width: $breakpoint-lg) {
      max-height: 200px;
      background-size: cover;
      background-position: center;
    }
  }

  &__icon {
    .slp-icon {
      width: 24px;
      height: 24px;
    }
  }
}

@media (max-width: 767px) {
  .horizontal-scroll {
    display: block;
  }
  h2 {
    width: 100%;
  }

  .slp-btn-tertiary {
    padding-left: 0;
  }

  .resources-block__cards {
    overflow-x: auto;
    scrollbar-width: none; // hides scrollbar on Firefox
    -ms-overflow-style: none; // hides scrollbar on IE 10+

    &::-webkit-scrollbar {
      // hides scrollbar on browsers that use that use Webkit (Chrome, Safari, Opera, etc)
      width: 0;
      height: 0;
    }

    flex-wrap: nowrap !important;

    .card {
      min-width: 270px;
      background: $color-surface-800;

      &:not(:last-of-type) {
        margin-right: $spacing-16;
      }
    }
  }
}
</style>
